#include <stdio.h>
#include <stdlib.h>

#define MAXN 1000000
#define MAXM 3000000

#define OSTRE_ODEVZDANI

static int Degree[MAXN];
static int Stack[MAXN];
static int nStack;

static int CurIndex[MAXN];
static int Fol[MAXN];
static int Orig[MAXN];
static int iFol[MAXN];

static int Resp[MAXN][6];
static int nResp[MAXN];
static int Thinks[MAXN][6];
static int Elects[MAXN];

static int Gone[MAXM];

static int nFriends[MAXN][5];
static int pocet[5];

void spioni(int n, int m, int z[][2], int* voli)
{
	for(int i = 0; i < n; i++)
	{
		Elects[i] = voli[i];
	}
	
    for(int i = 0; i < m; i++)
    {
		Degree[z[i][0]]++;
		Degree[z[i][1]]++;
    }
    
    for(int i = 0; i < n; i++)
    {
		if(Degree[i] <= 6)
		{
			Stack[nStack++] = i;
		}
    }
    
    for(int i = 0; i < n; i++)
	{
		iFol[i + 1] = iFol[i] + Degree[i];
	}
	
	int from, to;
	for(int i = 0; i < m; i++)
	{
		from = z[i][0];
		to = z[i][1];
		Fol[iFol[from] + CurIndex[from]] = to;
		Orig[iFol[from] + CurIndex[from]] = i;
		CurIndex[from]++;
		nFriends[from][Elects[to]]++;
		
		from = z[i][1];
		to = z[i][0];
		Fol[iFol[from] + CurIndex[from]] = to;
		Orig[iFol[from] + CurIndex[from]] = i;
		CurIndex[from]++;
		nFriends[from][Elects[to]]++;
		
		if(Elects[from] == Elects[to])
		{
			pocet[Elects[from]]++;
		}
	}

	while(nStack)
	{
		int cur = Stack[--nStack];
		
		for(int i = iFol[cur]; i < iFol[cur + 1]; i++)
		{
			if(Gone[Orig[i]])
			{
				continue;
			}
			
			to = Fol[i];
			Resp[cur][nResp[cur]] = to;
			Thinks[cur][nResp[cur]] = Elects[to];
			nResp[cur]++;
			Gone[Orig[i]] = 1;
			
			if(--Degree[to] == 6)
			{
				Stack[nStack++] = to;
			}
		}
	}
	
	/*printf("Jsme zodpovedni nasledovne, panove\n");
	
	for(int i = 0; i < n; i++)
	{
		printf("Vrchol %d:\n", i);
		for(int j = 0; j < nResp[i]; j++)
		{
			printf("%d%c", Resp[i][j], (j == nResp[i] - 1) ? '\n' : ' ');
		}
	}*/
}

void pocet_bodu(int p[5])
{
	for(int i = 0; i < 5; i++)
	{
		p[i] = pocet[i];
	}
}

void zmen_nazor(int spion, int voli)
{
	int to, cur = spion;
	for(int i = 0; i < nResp[cur]; i++)
	{
		to = Resp[cur][i];
		if(Thinks[cur][i] != Elects[to])
		{
			//printf("%d thought %d elects %d, but he elects %d\n", cur, to, Thinks[cur][i], Elects[to]);
			nFriends[cur][Thinks[cur][i]]--;
			Thinks[cur][i] = Elects[to];
			nFriends[cur][Thinks[cur][i]]++;
		}
	}
	
	//printf("%d elected %d, subtracting %d\n", cur, Elects[cur], nFriends[cur][Elects[cur]]);
	pocet[Elects[cur]] -= nFriends[cur][Elects[cur]];
	int prev = Elects[cur];
	Elects[cur] = voli;
	//printf("%d elects %d, adding %d\n", cur, Elects[cur], nFriends[cur][Elects[cur]]);
	pocet[Elects[cur]] += nFriends[cur][Elects[cur]];
	
	for(int i = 0; i < nResp[cur]; i++)
	{
		to = Resp[cur][i];
		nFriends[to][prev]--;
		nFriends[to][Elects[cur]]++;
		//printf("%d's friend %d elected %d, but now elects %d\n", to, cur, prev, Elects[cur]);
	}
}

#ifndef OSTRE_ODEVZDANI
int main()
{
	/*int z[4][2] = {{0, 1}, {1, 2}, {2, 0}, {2, 3}};
	int voli[4] = {0, 0, 1, 0};
	int pocet[5];
	
	spioni(4, 4, z, voli);
	pocet_bodu(pocet);
	for(int i = 0; i < 5; i++) printf("%d%c", pocet[i], (i == 4) ? '\n' : ' ');
	zmen_nazor(2, 0);
	pocet_bodu(pocet);
	for(int i = 0; i < 5; i++) printf("%d%c", pocet[i], (i == 4) ? '\n' : ' ');
	zmen_nazor(3, 1);
	pocet_bodu(pocet);
	for(int i = 0; i < 5; i++) printf("%d%c", pocet[i], (i == 4) ? '\n' : ' ');
	zmen_nazor(2, 1);
	pocet_bodu(pocet);
	for(int i = 0; i < 5; i++) printf("%d%c", pocet[i], (i == 4) ? '\n' : ' ');*/
	
	int voli[5] = {0, 3, 0, 2, 1};
	int z[10][2] =
	{
		{1, 3},
		{3, 4},
		{0, 3},
		{1, 2},
		{0, 2},
		{0, 4},
		{4, 2},
		{1, 0},
		{1, 4},
		{3, 2}
	};
	
	spioni(5, 10, z, voli);
	pocet_bodu(pocet);
	for(int i = 0; i < 5; i++) printf("%d%c", pocet[i], (i == 4) ? '\n' : ' ');
	zmen_nazor(1, 4);
	pocet_bodu(pocet);
	for(int i = 0; i < 5; i++) printf("%d%c", pocet[i], (i == 4) ? '\n' : ' ');
	zmen_nazor(1, 3);
	pocet_bodu(pocet);
	for(int i = 0; i < 5; i++) printf("%d%c", pocet[i], (i == 4) ? '\n' : ' ');
	zmen_nazor(3, 1);
	pocet_bodu(pocet);
	for(int i = 0; i < 5; i++) printf("%d%c", pocet[i], (i == 4) ? '\n' : ' ');
	zmen_nazor(0, 4);
	pocet_bodu(pocet);
	for(int i = 0; i < 5; i++) printf("%d%c", pocet[i], (i == 4) ? '\n' : ' ');
	zmen_nazor(2, 4);
	pocet_bodu(pocet);
	for(int i = 0; i < 5; i++) printf("%d%c", pocet[i], (i == 4) ? '\n' : ' ');
	
	return 0;
}
#endif
