program gamesa_main;
uses gamesa;

const MAXN=100000;
const P=400000;

var uhlopricky : array[0..MAXN] of dvojice;
    obarvena : array[0..2 * MAXN] of boolean;
    hrany : array[0..2 * MAXN] of dvojice;
    id_hrany : array[0..P] of longint;
    N, M : longint;

function hash (a, b : cardinal): cardinal;
begin
  hash := a * N + b;
end;

procedure pridej_hranu (a, b: longint);
  var tmp : longint;
      h : cardinal;
begin
  if a > b then
  begin
    tmp := a;
    a := b;
    b := tmp;
  end;

  h := hash (a, b) mod P;
  while id_hrany[h] <> 0 do h := (h + 1) mod P;

  hrany[M][0] := a;
  hrany[M][1] := b;
  inc(M);
  id_hrany[h] := M;
end;

function najdi_hranu (a, b: longint) : longint;
var h : cardinal;
    tmp : longint;
begin
  if a > b then
  begin
    tmp := a;
    a := b;
    b := tmp;
  end;

  h := hash (a, b) mod P;
  while id_hrany[h] <> 0 do
  begin
    if (hrany[id_hrany[h] - 1][0] = a) and (hrany[id_hrany[h] - 1][1] = b) then
    begin
      najdi_hranu := id_hrany[h] - 1;
      exit;
    end;
    h := (h + 1) mod P;
  end;

  najdi_hranu := -1;
end;

function obarveny_trojuhelnik (h : longint) : boolean;
var i, h1, h2 : longint;
begin
  for i := 0 to N - 1 do
  begin
    h1 := najdi_hranu(hrany[h][0], i);
    h2 := najdi_hranu(hrany[h][1], i);
    if (h1 <> -1) and (h2 <> -1) and obarvena[h1] and obarvena[h2] then
    begin
      obarveny_trojuhelnik := true;
      exit;
    end;
  end;
  obarveny_trojuhelnik := false;
end;

var i, h : longint;
    tah : dvojice;
    plan : text;
begin
  M := 0;
  for i := 0 to 2 * MAXN-1 do obarvena[i] := false;

  if ParamCount <> 1 then
  begin
    writeln (stderr, 'Ocekavam soubor s popisem hraciho planu jako argument.');
    exit;
  end;
  assign(plan, paramstr(1));
  reset(plan);
  if ioresult <> 0  then
  begin
    writeln (stderr, 'Popis hraciho planu nelze otevrit.');
    exit;
  end;

  read (plan, N);

  for i := 0 to n - 1 do pridej_hranu (i + 1, (i + 1) mod N + 1);
  for i := 0 to n - 4 do
  begin
      read (plan, uhlopricky[i][0], uhlopricky[i][1]);
      pridej_hranu (uhlopricky[i][0], uhlopricky[i][1]);
  end;
  close (plan);

  herni_plan (N, uhlopricky);
  
  while true do
  begin
    tah_honzika (tah);
    writeln (stderr, 'Tah Honzika: ', tah[0], ' ', tah[1]);

    h := najdi_hranu (tah[0], tah[1]);
    if h = -1 then
    begin
      writeln (stderr, 'Neexistujici hrana.');
      halt(1);
    end;
    
    if obarvena[h] then
    begin
      writeln (stderr, 'Jiz obarvena hrana.');
      halt(1);
    end;
    obarvena[h] := true;

    if obarveny_trojuhelnik (h) then
    begin
      writeln (stderr, 'Honzik vyhral.');
      exit;
    end;
    
    writeln (stderr, 'Tah Marenky?');
    
    while true do
    begin
      read (tah[0], tah[1]);
      if (tah[0] = 0) and (tah[1] = 0) then { nahodna hrana }
        begin
          repeat h := random (M); until not obarvena[h];
          tah[0] := hrany[h][0];
          tah[1] := hrany[h][1];
          writeln (stderr, 'Nahodny tah Marenky: ', tah[0], ' ', tah[1]);
        end
      else
        h := najdi_hranu (tah[0], tah[1]);
      if h = -1 then
      begin
        writeln (stderr, 'Hrana neexistuje; zadejte jinou.');
        continue;
      end;
      if obarvena[h] then
      begin
        writeln (stderr, 'Jiz obarvena hrana; zadejte jinou.');
        continue;
      end;
      break;
    end;
    obarvena[h] := true;

    if obarveny_trojuhelnik (h) then
    begin
      writeln (stderr, 'Marenka vyhrala.');
      exit;
    end;

    tah_marenky (tah);
  end;
end.
